#include "present.h"
#include<iostream>
using namespace std;
const int MAX_N=50004;
int nn;
int tree[MAX_N+3];
void update(int pos,int x)
{
    for(;;)
    {
        if(pos>nn)break;
        tree[pos]+=x;
        pos+=(pos&(-pos));
    }
}
int sum(int pos)
{
    int ans=0;
    for(;;)
    {
        if(pos<1)break;
        ans+=tree[pos];
        pos-=(pos&(-pos));
    }
    return ans;
}
int BinSearch(int x)
{
    int l=1,r=nn;
    int pos;
    while(l<=r)
    {
        int mid=(l+r)/2;
        int xx=sum(mid);
        if((xx<mid && question(mid,mid-xx)==x))
        {
            pos=mid;
            r=mid-1;
        }
        /*
        if(question(mid,mid-sum(mid))==x)
        {
            pos=mid;
            r=mid-1;
        }
        */
        else l=mid+1;
    }
    //cout<<pos<<endl;
    return pos;
}
std::vector < int > solve(int N)
{
    nn=N;
    std::vector < int > a(N);
    for(int i=nn;i>=1;i--)
    {
        int pos=BinSearch(i);
        update(pos,1);
        a[pos-1]=i;
    }
    /*for(int i=0;i<nn;i++)
    {
        if(a[i]==0)a[i]=1;
    }
    */
    return a;
}
