#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

bool check(const int n, int* perm, const vector <pair <int, int>> &flights)
{
    bool has5 = false;
    for (int i = 0; i < n; i++)
    {
        int currFlight = perm[i];

        if (flights[currFlight].first > i+1-has5 || flights[currFlight].second < i+1-has5)
            return false;

        if (perm[i] == 4)
        {
            has5 = true;
            if (i % 2 != 0)
                return false;
        }

    }

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int perm[10];
    int n;

    cin >> n;

    vector <pair <int, int>> flights;
    for (int i = 0; i < n+7; i++)
    {
        perm[i] = i;

        int x, y;
        cin >> x >> y;

        flights.push_back({x, y});
    }

    int ans = 0;
    do
    {
        if (check(n+7, perm, flights))
            ans++;


    }while (next_permutation(perm, perm+n+7));

    cout << ans << endl;

    return 0;
}
