#include<bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

long long power(long long a, long long b) {
    if(b == 1) {
        return a;
    }
    long long res = power(a,b/2);
    res*=res;
    res%=MOD;
    if(b%2) {
        res*=a;
        res%=MOD;
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,m,j = 2,ans = 0;
    cin >> n >> m;
    vector<bool> era(10000001,true);
    era[0] = false;
    era[1] = true;
    for(int i = 2; i*i <= 10000000; i++) {
        if(era[i]) {
            for(int j = i*2; j <= 10000000; j+=i) {
                era[j] = false;
            }
        }
    }
    vector<int> andr(10000001,0);
    andr[0] = false;
    andr[1] = false;
    for(int i = 2; i*i <= 10000000; i++) {
        if(era[i]) {
            for(int j = i; j <= 10000000; j+=i) {
                if(j%(i*i) != 0) {
                    andr[j]++;
                }
                else {
                    andr[j] = -INT_MAX;
                }
            }
        }
    }
    while(j <= m) {
        if(andr[j] >= 0) {
            ans+=((andr[j]%2)*2-1 )*power(m/j,n);
        }
        j++;
        ans%=MOD;
    }
    cout << (power(m,n)-ans+MOD)%MOD;
    return 0;
}
