
#include "present.h"
#include <vector>
#include <set>
#include <iostream>

std::vector < int > solve(int N)
{

    using namespace std;

    vector <int> a;
    bool found[400000] = {false};
    int k = question(1, 1);
    a.push_back(k);
    found[k] = true;

    vector <int> foundElments;
    for (int i = 2; i <= N; i++)
    {
        k = question(i, i);
        if (found[k] == false)
        {
            found[k] = true;
            a.push_back(k);
            continue;
        }

        int l = 1, r = i-1, mid;
        while (l <= r)
        {
            mid = (l+r)/2;
            k = question(i, mid);

            if (found[k] == false)
            {
                found[k] = true;
                foundElments.insert(foundElments.begin()+(mid-1), k);
                a.push_back(k);
                break;
            }

            if (foundElments[mid] > k)
                r = mid-1;
            else l = mid+1;
        }


    }

    return a;
}
