#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

constexpr int64_t mod = 1000000007;
int memo[10][10];

int solve(const int n, const int mx, int pos, int gcd)
{
    if (pos == n)
    {
        return (gcd==1);
    }

    if (memo[pos][gcd] != -1)
        return memo[pos][gcd];

    int ans = 0;
    for (int i = 1; i <= mx; i++)
        ans += (solve(n, mx, pos+1, __gcd(gcd, i))%mod);

    memo[pos][gcd] = ans;
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(memo, -1, sizeof(memo));
    int n, mx;
    cin >> n >> mx;

    cout << solve(n, mx, 0, 0) << endl;
    return 0;
}
